/**
 *  gen_array1.hpp
 *
 *  Generikus tömb.
 *  Előadáson bemutatott minimál változat.
 *  Nem ellenőriz, nem másolható, nem értékadható
 *    Az osztály definíciója és a tagfüggvények deklarációit
 *    nem tesszük külön fájlba, mivel a sablonok fordításánál
 *    mindkettőnek elérhetőnek kell lennie!
 */

template <class T>          // sablon kezdődik
class Array {               // osztálysablon
	T *tp;                  // elemek tömbjére mutató pointer
	int n;	 	            // tömb mérete
	Array(const Array&);    // másoló konstr. tiltása
	Array& operator=(const Array&); // tiltás
public:
	Array(int n=5) :n(n) {
        tp = new T[n];
    }
	T& operator[](int i);
    const T& operator[](int i) const;
	~Array() { delete[] tp; }
};

template <class T>          // tagfüggvénysablon
T& Array<T>::operator[](int i) {
	return tp[i];
}
