/**
 * fixed_size_gen_array.hpp
 *
 * Fix mérető tömb. A sablon példányosításakor eldől a méret.
 * Ezért minden méretre külön példányosodik az osztály, ami növeli a kód méretét
 */

#ifndef FIXED_SIZE_GEN_ARRAY_H
#define FIXED_SIZE_GEN_ARRAY_H
template <class T, unsigned int s>
class fixArray {
	T t[s];
	void chkIdx(unsigned i) const { if (i >= s) throw "Index hiba"; }
public:
    typedef T value_type;    // csak a insertionSort2 használja ki
	T& operator[](unsigned int i) {
		chkIdx(i);
        return t[i];
    }
     const T& operator[](unsigned int i) const {
		chkIdx(i);
        return t[i];
    }
};
#endif

