/**
 * generic_sort.hpp
 *
 * generikus rendező algoritmusok
 */

#ifndef GENERIC_SORT_H
#define GENERIC_SORT_H

template <typename T>
void swap(T& a, T& b) {
    T tmp = a; a = b; b = tmp;
}

// hagyományos tömbökhöz
// Megkapja az adat típust
template <typename T, class F>
void insertionSort(T a[], int n, F cmp) {
    for (int i = 1; i < n; i++) {
        T tmp = a[i];
        int j = i;
        while (j > 0 && cmp(tmp, a[j-1])) {
            a[j] = a[j-1];
            j--;
        }
        a[j] = tmp;
    }
}

// indexelhető tárolókhoz
// Elemtípust nem kap, a swap sablon levezeti
template <typename T, class F>
void insertionSort(T& a, int n, F cmp) {
    for (int i = 1; i < n; i++) {
        int j = i;
        while (j > 0 && cmp(a[j], a[j-1])) {
            swap(a[j], a[j-1]);
            j--;
        }
    }
}

// indexelhető tárolókhoz, melynek van value_type belső típusa
template <typename T, class F>
void insertionSort2(T& a, int n, F cmp) {
    for (int i = 1; i < n; i++) {
        typename T::value_type tmp = a[i];
        int j = i;
        while (j > 0 && cmp(tmp, a[j-1])) {
            a[j] = a[j-1];
            j--;
        }
        a[j] = tmp;
    }
}

#endif
