/**
 * pelda2Main.cpp
 *
 * Főprogram az előadáson bemutatott komplex példához (pelda2)
 * Feltételes fordítástól függ, hogy hagyományos C tömböt, vagy a sablonból
 * létrehozott indexelhető adatstruktúrát használják-e a generikus algoritmusok.
 */

#include <iostream>
#include "fixed_size_gen_array.hpp"
#include "generic_sort.hpp"
#include "generic_cmp.hpp"

/// Indexelhető típus elemeit kiírja egy stream-re
template <typename T>
void CopyToStream(const T& t, int n, std::ostream& os) {
    for (int i = 0; i < n; ++i)
        os << t[i] << ",";
    os << std::endl;
}

/// Indexelhető típus elemeit beolvassa egy stream-ről
template <typename T>
int ReadFromStream(T& t, unsigned int n, std::istream& is) {
    unsigned int cnt = 0;
    while (cnt < n && is >> t[cnt]) cnt++;
    return cnt;
}

/// predikátumos kiíró
template <typename T, class F>
void CopyToStream(const T& t, int n, std::ostream& os, F fun) {
    for (int i = 0; i < n; ++i)
        if (fun(t[i]))  os << t[i] << ",";
    os << std::endl;
}

#define FIXARRAY

int main() {
#ifdef FIXARRAY
// fixArray- változat
   std::cout << "FIXARRAY valtozat" << std::endl;
   std::cout << "Adjon max. 10 valos szamot:" << std::endl;
   fixArray<double, 10> be;	// max. 10 elemű double tömb

   int db = ReadFromStream(be, 10, std::cin); // beolvasunk
   std::cout << "A szamok :";
   CopyToStream(be, db, std::cout);	     // kiírjuk
   fixArray<double, 10> masolat = be;    // másolat készül
   fixArray<double, 10> masolat2 = be;  // másolat készül
   insertionSort(be, db, less<double>() ); // növekvő rendezés
   insertionSort(masolat, db, greater<double>() ); // csökkenő
   std::cout << "novekvo  :";
   CopyToStream(be, db, std::cout);	     // kiírjuk az elemeket
   std::cout << "csokkeno :";
   CopyToStream(masolat, db, std::cout);// kiírjuk az elemeket
   insertionSort2(masolat2, db, greater<double>() ); // csökkenő
   std::cout << "csokkeno :";
   CopyToStream(masolat2, db, std::cout);	    // kiírjuk az elemeket
   std::cout << "> mint 5 :";
   CopyToStream(be, db, std::cout, greater_than<int>(5));
   std::cout << "> mint 15:";
   CopyToStream(be, db, std::cout, greater_than<int>(15));
#else
// C tömb változat
   std::cout << "C tombvaltozat" << std::endl;
   std::cout << "Adjon max. 10 egesz szamot:" << std::endl;
   int ibe[10];

   int idb = ReadFromStream(ibe, 10, std::cin);
   std::cout << "A szamok :";
   CopyToStream(ibe, idb, std::cout);
   std::cout << "novekvo  :";
   insertionSort(ibe, idb, less<int>() );
   CopyToStream(ibe, idb, std::cout);
   std::cout << "> mint 5 :";
   CopyToStream(ibe, idb, std::cout, greater_than<int>(5));
   std::cout << "> mint 15:";
   CopyToStream(ibe, idb, std::cout, greater_than<int>(15));
#endif

}

