/**
 *
 * Ellads kdrszletei
 *
 */

#include <iostream>
#include <cstdlib>
using namespace std;

/// sablon osytly
template <class T1, class T2, int i  = 0>
struct V {
    T1 a1; T2 a2; int x;
    V() { x = i;}
};

/// Konstruktor specializcija <int, int>-re
template<>
V<int, int>::V() { a1=a2=x=0; }

/// generizlt beszr rendezs
template <class T>
void rendez (T a[], int n) {
    for (int i = 1; i < n; i++) {
        T tmp = a[i]; int j = i-1;
         while (j >= 0 && a[j] > tmp) {
             a[j+1] = a[j]; j--;
         }
         a[j+1] = tmp;
   }
}

/// csere
template<class T> void csere(T& p1, T& p2) {
    T tmp = p1; p1 = p2; p2 = tmp;
}

/// leg... kivlaszt
template<class T, int n, class S> T keres(T t[n]) {
    T tmp = t[0];
    for (int i = 1; i < n; i++) if (S::select(t[i], tmp)) tmp = t[i];
    return tmp;
}

/// nhny szoksos prediktum
template<class T> class Min {	// szoksos min. keresshez
public:
    static int select(T a, T b) { return a < b; }
};
template<class T> class Max {	// szoksos max. keressez
public:
    static int select(T a, T b) { return a > b; }
};

/// szoksostl eltr kivlaszt fggvny
class intMinAbs {
public:
    static int select(int a, int b) { return abs(a) < abs(b); }
};

/// template parameterknt megadott predikatmum fv.
template<class T, int n, int select(T, T)>T keresf(T t[n]) {
    T tmp = t[0];
    for (int i = 1; i < n; i++) if (select(t[i], tmp)) tmp = t[i];
    return tmp;
}

template<class T> int MinFv(T a, T b) {
    return a < b;
}

int main()
{
    V<int, char, 4> v1;
    V<double, int> v2;
    V<int, int> v3;     /// specializlt pldny

    int t[] = { 4, 8, -2, 88, 33, 1, 4, -1 };
    rendez<int>(t, 8);

    int x1 = 1, x2 = 2;
    csere(x1, x2);      /// template paramtert levezette

	int it[9] = {-5, -4, -3, -2, -1, 0, 1, 2, 3 };
    double dt[5] =  { .0,  .1,  .2,  .3,  4.4 };
	cout << keres<double, 5, Max<double> >(dt) << endl; // maximum
	cout << keres<int, 9, Min<int>  >(it) << endl; // mimimum
	cout << keres<int, 9, intMinAbs>(it) << endl;  // eltr kiv. fggvny
    cout << keresf<int, 9, MinFv>(it) << endl;

    return 0;
}
